#ifndef _cspublic_h_
#define _cspublic_h_

#include <tds.h>

#ifdef __cplusplus
extern "C" {
#endif 

static char  rcsid_cspublic_h [ ] =
         "$Id: cspublic.h,v 1.4 1998/11/13 02:09:10 camber Exp $";
static void *no_unused_cspublic_h_warn[]={rcsid_cspublic_h, no_unused_cspublic_h_warn};


typedef int CS_RETCODE ;

typedef TDS_INT CS_INT;
typedef TDS_SMALLINT CS_SMALLINT;
typedef TDS_TINYINT CS_TINYINT;
typedef TDS_CHAR CS_CHAR;
typedef float CS_REAL;
typedef double CS_FLOAT;
typedef char CS_BOOL;
typedef void CS_VOID;

#define CS_SUCCEED TDS_SUCCEED
#define CS_SIZEOF(x) sizeof(x)

/* FIX ME */
#define CS_NUMBER(x) (x)
#define CS_ORIGIN(x) (x)
#define CS_LAYER(x) (x)
#define CS_SEVERITY(x) (x)

typedef struct cs_context
{
	int dummy;
} CS_CONTEXT;

typedef struct cs_connection
{
	CS_CONTEXT *ctx;
	void *tds_login;
	TDSSOCKET *tds_socket;
} CS_CONNECTION;

typedef struct cs_command
{
	CS_CHAR *query;
	CS_CONNECTION *con;
} CS_COMMAND;

#define CS_MAX_MSG 1024
#define CS_MAX_NAME 132
#define CS_MAX_PREC 77  /* used by php */

typedef struct cs_datafmt {
	int datatype;
	int format;
	int maxlength;
	int count;
	int locale;
	int precision;
	int scale;
	int namelen;
	char name[CS_MAX_NAME];
	int status;
	int usertype;
} CS_DATAFMT;

typedef struct cs_money {
	int dummy;
} CS_MONEY;

typedef struct cs_money4 {
	int dummy;
} CS_MONEY4;

typedef struct cs_datetime {
	int dummy;
} CS_DATETIME;

typedef struct cs_datetime4 {
	int dummy;
} CS_DATETIME4;

typedef struct cs_daterec {
	CS_INT datesecond;
	CS_INT dateminute;
	CS_INT datehour;
	CS_INT datedmonth;
	CS_INT datemonth;
	CS_INT dateyear;
	CS_INT dateweek;
	CS_INT datedweek;
	CS_INT datemsecond;
} CS_DATEREC;

typedef struct cs_clientmsg {
	int severity;
	int msgnumber;
	char msgstring[CS_MAX_MSG];
	long osnumber;
	int osstringlen;
	char osstring[CS_MAX_MSG]; 
} CS_CLIENTMSG;

typedef struct cs_servermsg {
	int severity;
	int msgnumber;
	int state;
	int line;
	int svrnlen;
	char svrname[CS_MAX_NAME];
	int proclen;
	char proc[CS_MAX_NAME];
	char text[CS_MAX_MSG];
} CS_SERVERMSG;

typedef struct cs_locale {
	int dummy;	
} CS_LOCALE;

typedef struct cs_blkdesc {
	int dummy;	
} CS_BLKDESC;

#define CS_USERNAME	1
#define CS_NULLTERM	2
#define CS_FMT_NULLTERM	3
#define CS_SET		4
#define CS_UNUSED	5
#define CS_PASSWORD	6
#define CS_LANG_CMD	7
#define CS_ROW_RESULT	8
#define CS_ROW_FAIL	9
#define CS_END_DATA	10
#define CS_FAIL		11
#define CS_CMD_SUCCEED	12
#define CS_CMD_FAIL	13
#define CS_CMD_DONE	14
#define CS_END_RESULTS	15
#define CS_VERSION_100	16
#define CS_FORCE_EXIT	17
#define CS_MESSAGE_CB	18
#define CS_CLIENTMSG_CB 19
#define CS_SERVERMSG_CB 20
#define CS_GET		25
#define CS_CON_STATUS 26
#define CS_FORCE_CLOSE 27
#define CS_CONSTAT_CONNECTED 28
#define CS_SYNC_IO	29
#define CS_NETIO	30
#define CS_IFILE	31
#define CS_APPNAME	32
#define CS_HOSTNAME	33
#define CS_PACKETSIZE	34
#define CS_SEC_ENCRYPTION	36
#define CS_LC_ALL	37
#define CS_SYB_LANG	38
#define CS_SYB_CHARSET	39
#define CS_LOC_PROP	40
#define CS_SV_COMM_FAIL	41
#define CS_BULK_LOGIN	42
#define BLK_VERSION_100 CS_VERSION_100
#define CS_BLK_IN	43
#define CS_BLK_OUT	44
#define CS_BLK_BATCH	45
#define CS_BLK_ALL	46
#define CS_BLK_CANCEL	47
#define CS_CANCEL_ALL	48
#define CS_NUMDATA	49
#define CS_CANCEL_ATTN	50
#define CS_PARENT_HANDLE	51
#define CS_COMPUTE_RESULT	52
#define CS_BYLIST_LEN	53
#define CS_COMP_BYLIST	54
#define CS_COMP_OP	55
#define CS_COMP_COLID	56
#define CS_NO_COUNT	57
#define CS_STATUS_RESULT	58
#define CS_ROW_COUNT	59
#define CS_OP_SUM	60
#define CS_OP_AVG	61
#define CS_OP_MIN	62
#define CS_OP_MAX	63
#define CS_OP_COUNT	64
#define CS_PARAM_RESULT	65
#define CS_FMT_UNUSED	66
#define CS_CANCEL_CURRENT	67
#define CS_COMPUTEFMT_RESULT	68
#define CS_ROWFMT_RESULT	69
#define CS_DESCRIBE_RESULT	70
#define CS_MSG_RESULT	71

/* bind types */
#define CS_CHAR_TYPE	1
#define CS_INT_TYPE	2
#define CS_SMALLINT_TYPE	3
#define CS_TINYINT_TYPE	4
#define CS_MONEY_TYPE	5
#define CS_DATETIME_TYPE	6
#define CS_NUMERIC_TYPE	7
#define CS_DECIMAL_TYPE	8
#define CS_DATETIME4_TYPE	9
#define CS_MONEY4_TYPE	10
#define CS_IMAGE_TYPE	11
#define CS_BINARY_TYPE	12
#define CS_BIT_TYPE	13
#define CS_REAL_TYPE	14
#define CS_FLOAT_TYPE	15
#define CS_TEXT_TYPE	16
#define CS_VARCHAR_TYPE	17
#define CS_VARBINARY_TYPE	18

/* */
#define CS_FALSE	0
#define CS_TRUE	1

#ifdef __cplusplus
}
#endif 

#endif

