#include <tds.h>

static char  software_version[]   = "$Id: server.c,v 1.3 1998/11/07 06:37:22 camber Exp $";
static void *no_unused_var_warn[] = {software_version,
                                     no_unused_var_warn};


tds_env_change(TDSSOCKET *tds,int type, char *newvalue, char *oldvalue)
{
TDS_SMALLINT totsize;
	switch(type) {
		case 1:
			/* totsize = type + newlen + newvalue + oldlen + oldvalue  */
			totsize = strlen(newvalue) + 3;
			tds_put_smallint(tds, totsize);
			tds_put_byte(tds,type);
			tds_put_byte(tds,strlen(newvalue));
			tds_put_n(tds,newvalue,strlen(newvalue));
			tds_put_byte(tds,strlen(oldvalue));
			tds_put_n(tds,oldvalue,strlen(oldvalue));
			break;
		case 2:
			/* totsize = type + len + string + \0 */
			totsize = strlen(newvalue) + 3;
			tds_put_smallint(tds, totsize);
			tds_put_byte(tds,type);
			tds_put_byte(tds,strlen(newvalue));
			tds_put_n(tds,newvalue,strlen(newvalue));
			tds_put_byte(tds,'\0');
			break;
		case 4:
			/* totsize = type + len + string + \0 */
			totsize = strlen(newvalue) + 3;
			tds_put_smallint(tds, totsize);
			tds_put_byte(tds,type);
			tds_put_byte(tds,strlen(newvalue));
			tds_put_n(tds,newvalue,strlen(newvalue));
			tds_put_byte(tds,'\0');
			break;
	}
}

void tds_send_msg(TDSSOCKET *tds,int msgno, int msgstate, int severity,
	char *msgtext, char *srvname, char *procname, int line)
{
int totsize;

	if IS_TDS42(tds) {
		tds_put_byte(tds,TDS_MSG_TOKEN);
	} else {
		tds_put_byte(tds,TDS_MSG50_TOKEN);
		tds_put_smallint(tds,totsize);
		tds_put_smallint(tds,msgno);
		tds_put_smallint(tds,0); /* unknown */
		tds_put_byte(tds, msgstate);
		tds_put_byte(tds, severity);
		tds_put_byte(tds,strlen(procname));
		tds_put_n(tds,procname,strlen(procname));
		tds_put_byte(tds,0); /* unknown */
		tds_put_byte(tds,1); /* unknown */
		tds_put_byte(tds,0); /* unknown */
		tds_put_smallint(tds,strlen(msgtext));
		tds_put_n(tds,msgtext,strlen(msgtext));
		tds_put_byte(tds, severity);
		tds_put_byte(tds,strlen(srvname));
		tds_put_n(tds,srvname,strlen(srvname));
		tds_put_byte(tds,0); /* unknown */
		tds_put_byte(tds,1); /* unknown */
		tds_put_byte(tds,0); /* unknown */
	}
}
void tds_send_err(TDSSOCKET *tds,int severity, int dberr, int oserr, char *dberrstr, char *oserrstr)
{
}
void tds_send_login_ack(TDSSOCKET *tds, char *progname)
{
	tds_put_byte(tds,TDS_LOGIN_ACK_TOKEN);
	tds_put_smallint(tds,9+strlen(progname)); /* length of message */
	if IS_TDS42(tds) {
		tds_put_byte(tds,1);
		tds_put_byte(tds,4);
		tds_put_byte(tds,2);
	} else {
		tds_put_byte(tds,5);
		tds_put_byte(tds,5);
		tds_put_byte(tds,0);
	}
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,0); /* unknown */
	tds_put_string(tds,progname,strlen(progname)); 
	tds_put_byte(tds,1); /* unknown */
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,0); /* unknown */
	tds_put_byte(tds,1); /* unknown */
}
tds_send_226_token(TDSSOCKET *tds)
{
	tds_put_byte(tds,226);
	tds_put_byte(tds,18);
	tds_put_byte(tds,0);
	tds_put_byte(tds,1);
	tds_put_byte(tds,7);
	tds_put_byte(tds,3);
	tds_put_byte(tds,97);
	tds_put_byte(tds,65);
	tds_put_byte(tds,207);
	tds_put_byte(tds,255);
	tds_put_byte(tds,255);
	tds_put_byte(tds,230);
	tds_put_byte(tds,2);
	tds_put_byte(tds,7);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,2);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
}
tds_send_253_token(TDSSOCKET *tds)
{
	tds_put_byte(tds,253);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,2);
	tds_put_byte(tds,0);
	tds_put_byte(tds,1);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
	tds_put_byte(tds,0);
}
