#include "tdsutil.h"

static char  software_version[]   = "$Id: read.c,v 1.3 1998/11/20 21:04:27 greggj Exp $";
static void *no_unused_var_warn[] = {software_version,
                                     no_unused_var_warn};


unsigned char tds_get_byte(TDSSOCKET *tds)
{
	if (tds->in_pos >= tds->in_len) {
		if(!tds_read_packet(tds))
			return (0);
	}
	return tds->in_buf[tds->in_pos++];
}
void tds_unget_byte(TDSSOCKET *tds)
{
	/* this is a one trick pony...don't call it twice */
	tds->in_pos--;
}
TDS_SMALLINT tds_get_smallint(TDSSOCKET *tds)
{
TDS_SMALLINT ret;
unsigned char hibyte, lobyte;

	lobyte = tds_get_byte(tds);
	hibyte = tds_get_byte(tds);
	return (TDS_SMALLINT) lobyte+(hibyte*256);
}
char *tds_get_n(TDSSOCKET *tds, void *dest, int n)
{
/* FIX ME -- a more direct return of the data if possible, at least memcpy from the buffer area. going byte-by-byte will be slow. */
unsigned char buf[BUFSIZ];
int pos,i;

	pos = 0;
	for (i=0;i<n;i++)
		buf[pos++]=tds_get_byte(tds);	
	
	if (dest==NULL) return NULL;

	memcpy(dest,buf,n);
	return dest;
}
int get_size_by_type(int servertype)
{
	switch(servertype) {
	case SYBINT1: 
		return 1;
		break;
	case SYBINT2: 
		return 2;
		break;
	case SYBINT4: 
		return 4;
		break;
	case SYBFLT8: 
		return 8;
		break;
	case SYBDATETIME: 
		return 8;
		break;
	case SYBDATETIME4: 
		return 8;
		break;
	case SYBBIT: 
		return 1;
		break;
	case SYBMONEY:
		return 8;
		break;
	case SYBMONEY4:
		return 4;
		break;
	}
}
int tds_read_packet (TDSSOCKET *tds)
{
int len;
static unsigned char mybuf[BUFSIZ];

	/* FIX ME -- add packetsize support */
	if((len = read(tds->s, mybuf, 512)) <= 0)
	{
		tds->in_len=0;
		tds->in_pos=0;
		tds->last_packet=1;
		return(0);
	}
	if (mybuf[1]) tds->last_packet=1;
	else tds->last_packet=0;
	tds->in_pos = 0; 

/* Note:
** this was done by Gregg, I don't think its the real solution (it breaks 
** under 5.0, but I haven't gotten a result big enough to test this yet.
*/
	if (IS_TDS42(tds)) {
		if(mybuf[0] == '\004')
		{
			tds->in_len = len - 8; /* skip header stuff */
			memcpy(tds->in_buf,&mybuf[8],tds->in_len);
		} else {
			tds->in_len = len;
			memcpy(tds->in_buf,mybuf,tds->in_len);
		}

	} else {
		tds->in_len = len - 8; /* skip header stuff */
		memcpy(tds->in_buf,&mybuf[8],tds->in_len);
	}

	return tds->in_len;
} 
